//
//  DXRssChannel.h
//  DXSearchers
//
//  Created by Oliver Kahrmann on 01.04.11.
//  Copyright 2011 DHELIXSoft. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXRssCloudInfo.h"
#import "DXRssImage.h"
#import "DXRssTextInput.h"
#import "DXRssItem.h"


@interface DXRssChannel : NSObject {
	NSString *_rssVersion;
	
	NSString *_title;
	NSString *_link;
	NSString *_description;
	
	NSString *_language;
	NSString *_copyright;
	NSString *_managingEditor;
	NSString *_webMaster;
	NSDate *_pubDate;
	NSDate *_lastBuildDate;
	NSMutableArray *_category;
	NSString *_docs;
	NSString *_generator;
	DXRssCloudInfo *_cloud;
	uint _ttl;
	DXRssImage *_image;
	NSString *_rating;
	DXRssTextInput *_textInput;
	NSMutableArray *_skipHours;
	NSMutableArray *_skipDays;
	
	
	
	NSMutableArray *_rssItems;
	
	NSString *_encoding;
}
- (void)fixNilValues;

- (NSXMLDocument *)xmlDocumentRepresentation;

- (NSString *)rssVersion;
- (void)setRssVersion:(NSString *)value;

- (NSString *)title;
- (void)setTitle:(NSString *)value;

- (NSString *)link;
- (void)setLink:(NSString *)value;

- (NSString *)description;
- (void)setDescription:(NSString *)value;

- (NSString *)language;
- (void)setLanguage:(NSString *)value;

- (NSString *)copyright;
- (void)setCopyright:(NSString *)value;

- (NSString *)managingEditor;
- (void)setManagingEditor:(NSString *)value;

- (NSString *)webMaster;
- (void)setWebMaster:(NSString *)value;

- (NSDate *)pubDate;
- (void)setPubDate:(NSDate *)value;

- (NSDate *)lastBuildDate;
- (void)setLastBuildDate:(NSDate *)value;

- (NSArray *)category;
- (unsigned)countOfCategory;
- (id)objectInCategoryAtIndex:(unsigned)theIndex;
- (void)getCategory:(id *)objsPtr range:(NSRange)range;
- (void)insertObject:(id)obj inCategoryAtIndex:(unsigned)theIndex;
- (void)removeObjectFromCategoryAtIndex:(unsigned)theIndex;
- (void)replaceObjectInCategoryAtIndex:(unsigned)theIndex withObject:(id)obj;

- (NSString *)docs;
- (void)setDocs:(NSString *)value;

- (NSString *)generator;
- (void)setGenerator:(NSString *)value;

- (DXRssCloudInfo *)cloud;
- (void)setCloud:(DXRssCloudInfo *)value;

- (uint)ttl;
- (void)setTtl:(uint)value;

- (DXRssImage *)image;
- (void)setImage:(DXRssImage *)value;

- (NSString *)rating;
- (void)setRating:(NSString *)value;

- (DXRssTextInput *)textInput;
- (void)setTextInput:(DXRssTextInput *)value;

- (NSArray *)skipHours;
- (unsigned)countOfSkipHours;
- (id)objectInSkipHoursAtIndex:(unsigned)theIndex;
- (void)getSkipHours:(id *)objsPtr range:(NSRange)range;
- (void)insertObject:(id)obj inSkipHoursAtIndex:(unsigned)theIndex;
- (void)removeObjectFromSkipHoursAtIndex:(unsigned)theIndex;
- (void)replaceObjectInSkipHoursAtIndex:(unsigned)theIndex withObject:(id)obj;

- (NSArray *)skipDays;
- (unsigned)countOfSkipDays;
- (id)objectInSkipDaysAtIndex:(unsigned)theIndex;
- (void)getSkipDays:(id *)objsPtr range:(NSRange)range;
- (void)insertObject:(id)obj inSkipDaysAtIndex:(unsigned)theIndex;
- (void)removeObjectFromSkipDaysAtIndex:(unsigned)theIndex;
- (void)replaceObjectInSkipDaysAtIndex:(unsigned)theIndex withObject:(id)obj;

- (NSArray *)rssItems;
- (unsigned)countOfRssItems;
- (id)objectInRssItemsAtIndex:(unsigned)theIndex;
- (void)getRssItems:(id *)objsPtr range:(NSRange)range;
- (void)insertObject:(id)obj inRssItemsAtIndex:(unsigned)theIndex;
- (void)removeObjectFromRssItemsAtIndex:(unsigned)theIndex;
- (void)replaceObjectInRssItemsAtIndex:(unsigned)theIndex withObject:(id)obj;

- (NSString *)encoding;
- (void)setEncoding:(NSString *)value;

@end
